
;==============================================================================
;PHOS  -  MASM32/WIN32 - 2009 BY MICHAEL MANGELSDORF  -  LICENSE: PUBLIC DOMAIN
;==============================================================================

.386
.model flat, stdcall   
option casemap :none  

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\comctl32.inc
include \masm32\include\masm32.inc
include \masm32\include\shell32.inc
include \masm32\include\advapi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\advapi32.lib

;==============================================================================
;UNINITIALIZED DATA = UNINITIALIZED DATA = UNINITIALIZED DATA = UNINITIALIZED==
;==============================================================================

.DATA?
ALIGN 4

szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

hWnd                            dd ?   ;application window handle
hInstance                       dd ?
CommandLine                     dd ?
ThreadID                        dd ?   ;identifies the running user thread
hphos_thread_func               dd ?   ;user thread handler
hIcon                           dd ?   ;handle for default application icon
hIconMain                       dd ?   ;handle for main application icon 
hBackBufOldBmp                  dd ?   ;temporary store
hCharMapOldBmp                  dd ?   ;temporary store
hBackBufBmp                     dd ?   ;handle for the back buffer
hBackBufDC                      dd ?   ;device context for the back buffer
hCharMapBmp                     dd ?   ;handle for the character bitmap
hCharMapDC                      dd ?   ;device context for the character bitmap
FgCol                           dd ?   ;text foreground color
BgCol                           dd ?   ;text background color
OsCol                           dd ?   ;client region overscan color

Ps PAINTSTRUCT <?>

TempRect RECT <?>

phosThreadInfo STRUC
    hWin           DD ?
    ptrLineBuffer  DD ?
    reason         DD ?
phosThreadInfo ENDS

threadInfo phosThreadInfo <?, ?, ?>

phos_thread_ptr                 dd ?
init_callback_ptr               dd ?   ;function provided by DLL user
exit_callback_ptr               dd ?   ;function provided by DLL user

;==============================================================================
;INITIALIZED DATA = INITIALIZED DATA = INITIALIZED DATA = INITIALIZED DATA ====
;==============================================================================

.DATA
ALIGN 4

paddingLeft                     TEXTEQU <16>
paddingTop                      TEXTEQU <16>
nLinesMax                       TEXTEQU <48>   ;number of lines in the console
nLinesStart                     TEXTEQU <10>   ;number of lines at beginning
nCols                           TEXTEQU <64>   ;number of columns in the console
colWidth                        TEXTEQU <9>    ;character width in pixels
lineHeight                      TEXTEQU <17>   ;character height in pixels

paddedClientWidth               TEXTEQU %(nCols * colWidth + 2 * paddingLeft)
paddedClientHeightMax           TEXTEQU %(nLinesMax * lineHeight + 2 * paddingTop)
paddedClientHeightMin           TEXTEQU %(nLinesStart * lineHeight + 2 * paddingTop)
bottomLine                      TEXTEQU %((nLinesMax-1) * lineHeight + paddingTop)

spaceChar                       TEXTEQU <32> ;ASCII space
WM_FINISH                       EQU WM_USER + 123
WM_PHOS_READY                   EQU WM_USER + 124

;the following three variables are used in most functions to do with
;moving the cursor. max_pos_x indicates the last character in the phrase
;the user has typed on the prompt line. cursor_pos_x holds the current position
;of the cursor on the prompt line. insert_pos_x is the position, where the next
;character typed will be inserted on the prompt line.

max_pos_x                       dd 0
cursor_pos_x                    dd 0
insert_pos_x                    dd 0

threadBusy                      dd 0       ;set to one by WM_TIMER handler
TimerID                         dd 1664    ;an arbitrary value
timer_ms                        dd 1000    ;timer interval in milliseconds

paddedClientHeightCurrent       dd paddedClientHeightMin
char_width                      dd colWidth

SizingRect RECT <0, 0, paddedClientWidth, paddedClientHeightMin>

szDemoText                      db "Thread says hello!", 0
szPhosGreet                     db "phOS Win32 CP1252/VGA", 0
szPhosHelp                      db "type 'exit' to quit", 0
szWindowCaptionPrefix           db "phOS", 0
szWindowCaption                 db 128 dup (0)

ptrCaptionPrefix                dd OFFSET szWindowCaptionPrefix

;The following two variables reserve one byte more than the number of columns.
;This is because when the point of character insertion is at the last character
;of the line, the cursor (which is displayed in front of it) needs parking.
;lineBuffer holds the character codes of the prompt line string.

szEmptyLine                     db nCols + 1 dup (spaceChar), 0
lineBuffer                      db nCols + 1 dup (spaceChar), 0

;The following define a few colors for convenience. ColOVERSCAN is the paint
;for wherever no characters appear on the client region. That isn't the same
;as BgCol (see above). Each character (FgCol) is printed on its own little
;rectangle (BgCol). The grid that appears to be separating the little
;rectangles is ColOVERSCAN.

ColBLACK                        dd 00000000h
ColBLUE                         dd 00FF0000h
ColGREEN                        dd 0000FF00h
ColCYAN                         dd 00FFFF00h
ColRED                          dd 000000FFh
ColMAGENTA                      dd 00FF00FFh
ColBROWN                        dd 00FFFF00h
ColGREY                         dd 00C0C0C0h
ColYELLOW                       dd 0000FFFFh
ColWHITE                        dd 00FFFFFFh

ColOLIVE                        dd 00002200h
ColOVERSCAN                     dd 00001400h

window_style                    dd WS_OVERLAPPEDWINDOW and not WS_MAXIMIZEBOX
window_style_ex                 dd 0 ;WS_EX_OVERLAPPEDWINDOW

;==============================================================================
;PROTOTYPES = PROTOTYPES = PROTOTYPES = PROTOTYPES = PROTOTYPES = PROTOTYPES ==
;==============================================================================

DllEntry             PROTO :DWORD, :DWORD, :DWORD
phos_start_window    PROTO :DWORD, :DWORD, :DWORD, :DWORD

;blitcursor inverts the character at the current cursor position.
;It displays the cursor. Update cursor does not remove the cursor.
;repaint_line redisplays all characters after the current insertion point,
;implicitly removing the cursor.

blitcursor           PROTO
repaint_line         PROTO

submit_prompt        PROTO :DWORD

create_user_thread   PROTO :DWORD
thread_return        PROTO

blitchar             PROTO :DWORD, :DWORD, :DWORD
blitline             PROTO :DWORD, :DWORD

updateWindowCaption  PROTO
phos_set_colorscheme PROTO :DWORD, :DWORD, :DWORD
phos_set_caption     PROTO :DWORD
phos_printstr        PROTO :DWORD, :DWORD, :DWORD
phos_thread_func     PROTO :DWORD
phos_init_callback   PROTO :DWORD, :DWORD
phos_exit_callback   PROTO
phos_vscroll         PROTO

;the WinMain function is an important part of any windows application;
;important settings are made and the application window is created;
;also includes the message loop; whenever anything happens to
;the application window (mouse clicks, keypress etc), the message loop turns
;round once and calls a special function called WndProc (see below)
;to deal with the event

WinMain            PROTO :DWORD, :DWORD, :DWORD, :DWORD

;WndProc deals with OS events relevant to our application

WndProc            PROTO :DWORD, :DWORD, :DWORD, :DWORD

clear_backbuffer   PROTO ;backbuffer filled with ColOVERSCAN
fill_overscan      PROTO :DWORD
charmap_setup      PROTO ;bitmap containing the character cells
backbuffer_init    PROTO ;character grid and a greeting
backbuffer_setup   PROTO ;bitmap used for double buffering

TopXY              PROTO :DWORD, :DWORD
newline            PROTO