
#include <windows.h>

#define WM_FINISH WM_USER + 123
#define APP_ICON 123

#define PETROL_GREEN 0x0000FF00, 0x00002200, 0x00001400

HANDLE hInstMain;

struct phos_thread_info
{
    HANDLE hWin;
    char* ptrLineBuffer;
    unsigned reason;    
};

void phos_thread_func( struct phos_thread_info*);
void phos_init_callback( HANDLE hWin, HANDLE hInstDll );
void phos_exit_callback( void );

void (APIENTRY *pfn_phos_start_window)( void (*func)(struct phos_thread_info*),
                                        void (*init_callback)(HANDLE hWin, HANDLE hInstDll),
                                        void (*exit_callback)(void),
                                        HICON ico );

void (APIENTRY *pfn_phos_set_colorscheme)(unsigned r, unsigned g, unsigned b);

void (APIENTRY *pfn_phos_vscroll)(void);

void (APIENTRY *pfn_phos_set_caption)(char* str);

int (APIENTRY *pfn_phos_printstr)(char* str, unsigned color, unsigned pos);


int load_DLL_functions( void)
{
    char buffer[1024];
    int status = 1;
    
    HANDLE dllHandle = LoadLibrary( "phos32.dll" );

    if (dllHandle == INVALID_HANDLE_VALUE)
    {
        fprintf( stderr, "DLL load failure\n" );
        status = 0;
    }

    pfn_phos_start_window     = GetProcAddress( dllHandle, "phos_start_window" );
    pfn_phos_set_colorscheme  = GetProcAddress( dllHandle, "phos_set_colorscheme" );
    pfn_phos_vscroll          = GetProcAddress( dllHandle, "phos_vscroll" ); 
    pfn_phos_set_caption      = GetProcAddress( dllHandle, "phos_set_caption" );
    pfn_phos_printstr         = GetProcAddress( dllHandle, "phos_printstr" );
     
    if (pfn_phos_start_window == NULL) // spot check
    {
        fprintf(stderr, "DLL function missing\n" );
        status = 0;
    }       
    
    return status;
}